﻿Type=Activity
Version=1.80
FullScreen=False
IncludeTitle=False
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	'Database
	Dim SQL1 As SQL
	Dim DBFileDir As String			: DBFileDir = File.DirDefaultExternal
	Dim DBFileName As String		: DBFileName = "alliedrota.sqlite"
	Dim DBFileBak As String			: DBFileBak = "alliedrota.bak"
	
	Dim MDate As Long
	Dim CurrDate As String
	Dim FName, LName, Postal, StartTime, EndTime, ThisDate As String
	
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Dim LayoutPanel As Panel
	Dim anim As Animation

	'Main Screen
	Dim Calendar_Button As Button
	Dim DateLabel As Label
	Dim Next_Button As Button
	Dim Prev_Button As Button
	
	'Dates
	Dim now As Long
	Dim dt As String
	Dim dth As String
	Dim Today As Long
	
	'Scroll View List
	Dim scvList As ScrollView
	Dim pnlList As Panel
	Dim FontColor As Int		: FontColor = Colors.Blue
	Dim RowHeight As Int		: RowHeight = 80dip
	Dim RowColor As Int			: RowColor = Colors.Transparent
	Dim LineColor As Int		: LineColor = Colors.Transparent
	Dim NumberOfRows As Int		: NumberOfRows = 0
	Dim VisibleRows As Int
	Dim SelectedItem As Int		: SelectedItem = -1
	Dim SelectedRowColor As Int	: SelectedRowColor = Colors.LightGray
	Dim Alignment As Int		: Alignment = Gravity.LEFT
	Dim FontSize As Float		: FontSize = 12

	Dim Label1, Label2, Label3, Label4, Label5 As Label
	
	Dim FrButton, MoButton, SaButton, SuButton, ThButton, TuButton, WeButton As Button
	Dim FrLab, MoLab, SaLab, SuLab, ThLab, TuLab, WeLab As Label
	Dim FrDat, MoDat, SaDat, SuDat, ThDat, TuDat, WeDat As String

	Dim NSTLabel As Label
	Dim CName(), STim(), ETim(), PostCD() As String
	
	Dim TodayButton As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)

	If FirstTime Then
		If File.Exists(DBFileDir, DBFileName) = False Then
			File.Copy(File.DirAssets, DBFileName, DBFileDir, DBFileName)
			SQL1.Initialize(DBFileDir, DBFileName, True)
		Else
			SQL1.Initialize(DBFileDir, DBFileName, False)
		End If
	End If
	
	Activity.AddMenuItem2("Exit", "mnuExit", LoadBitmap(File.DirAssets, "exit.png"))
	Activity.AddMenuItem2("Data", "mnuData", LoadBitmap(File.DirAssets, "data.png"))
	Activity.AddMenuItem2("Info", "mnuInfo", LoadBitmap(File.DirAssets, "info.png"))
	Activity.AddMenuItem2("Add Shift", "mnuNewShift", LoadBitmap(File.DirAssets, "newrota.png"))
	Activity.AddMenuItem2("New Client", "mnuNewClient", LoadBitmap(File.DirAssets, "newclient.png"))
	Activity.AddMenuItem2("Client Details", "mnuDetails", LoadBitmap(File.DirAssets, "clients.png"))
	
	LoadLayoutToPanel("day_list.bal")
	
	DateTime.DateFormat = "dd/MM/yyyy"
	DateRoutines(DateTime.Date(DateTime.now))
	
	DateTime.DateFormat = "EEEE"
	dt = DateTime.Date(DateTime.now)
	ChangeDayButton(dt)
	
	DateTime.DateFormat = "dd/MM/yyyy"
	dt = DateTime.Date(DateTime.now)
	
	FillScrollView

End Sub

Sub Activity_Resume

	Dim DateIn As String
	
	DateTime.DateFormat = "dd/MM/yyyy"
  	DateIn = DateTime.Date(DateTime.now)

 	If KalenderActivity.DaySelected > 0 Then
  		DateTime.DateFormat = "dd/MM/yyyy"
  		DateIn = DateTime.Date(KalenderActivity.DaySelected)
  		DateRoutines(DateIn)
 	End If
 
 	KalenderActivity.DaySelected = 0
	
	dt = DateIn
	FillScrollView
 
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub LoadLayoutToPanel (Layout As String)
	If LayoutPanel.IsInitialized Then
		anim.InitializeAlpha("", 1, 0)
		anim.Duration = 1000
		anim.Start(LayoutPanel)
		
		Activity.RemoveViewAt(0)
	End If
	
	LayoutPanel.Initialize("")
	LayoutPanel.LoadLayout(Layout)
	Activity.AddView(LayoutPanel,0,0,100%x,100%y)
End Sub

Sub mnuExit_Click
	Activity.Finish
End Sub

Sub mnuNewShift_Click
	StartActivity("NewShift")
End Sub

Sub mnuNewClient_Click
	StartActivity("NewClient")
End Sub

Sub mnuDetails_Click
	StartActivity("ClientDetails")
End Sub

Sub mnuData_Click
	StartActivity("DataControl")
End Sub

Sub mnuInfo_Click
	Dim txt As String
	
	txt = "Allied Rota is meant to assist in keeping a record of shift with the "
	txt = txt & "company." & CRLF & "Copyright 2012 Steven Waugh."
	
	Msgbox(txt, "")
End Sub

Sub FillScrollView
	Dim Cursor1 As Cursor
	Dim dbtxt As String
	Dim Panel0 As Panel
	Dim PanelTop, Lst As Int
	Dim Text1, Text2, Text3, Text4 As String

	dbtxt = "SELECT * FROM Shifts WHERE Shift_Date = '" & CurrDate & "' ORDER BY Start ASC"
	
	
	Cursor1 = SQL1.ExecQuery(dbtxt)
	
	ThisDate = CurrDate
	
	PanelTop=0
	Panel0.Initialize("")
	Panel0=scvList.Panel
	Panel0.Color=Colors.Transparent

	If Cursor1.RowCount = 0 Then
		Panel0.Visible = False
		NSTLabel.Visible = True
		Return
	End If
	
	Lst = Cursor1.RowCount
	Dim CName(Lst) As String
	Dim STim(Lst) As String
	Dim ETim(Lst) As String
	Dim PostCD(Lst) As String

	For i=0 To Cursor1.RowCount - 1
	
		Dim Panel1 As Panel
		Dim Label1, Label2, Label3, Label4 As Label
	
		Cursor1.Position = i
		Text1 = Cursor1.GetString("Client")
		Text2 = Cursor1.GetString("PostCode")
		Text3 = Cursor1.GetString("Start")
		Text4 = Cursor1.GetString("End")
		
	 	Panel1.Initialize("Panel1")
		Panel1.Tag = i
		Panel0.AddView(Panel1,0,PanelTop,480,102dip)
		Panel1.Color=Colors.White
		
		Label1.Initialize("")
		Panel1.AddView(Label1,60, 0, 410, 50)
		Label1.TextSize = 20
		Label1.TextColor = FontColor
		Label1.Text = Text1
		CName(i) = Text1
		Label1.Gravity=Gravity.CENTER

		Label2.Initialize("")
		Panel1.AddView(Label2,60, 50, 410, 50)
		Label2.TextSize = 14
		Label2.TextColor = FontColor
		Label2.Text = Text2
		PostCD(i) = Text2
		Label2.Gravity=Gravity.CENTER
			
		Label3.Initialize("")
		Panel1.AddView(Label3,0, 0, 60, 100)
		Label3.Tag = i
		Label3.Text = Text3 & CRLF & Text4
		STim(i) = Text3
		ETim(i) = Text4
		Label3.TextSize = 12
		Label3.TextColor = FontColor
		Label3.Gravity = Gravity.CENTER
		
		Label4.Initialize("")
		Label4.SetBackgroundImage(LoadBitmap(File.DirAssets, "divider.png"))
		Panel1.AddView(Label4,0, 101, 480, 2)
			
		PanelTop=PanelTop+103
	Next
	Cursor1.Close
	
	NSTLabel.Visible = False
	Panel0.Visible = True
	
	Panel0.Height=PanelTop

End Sub

Sub Wait(Secs As Int)
   Dim Ti As Long
   Ti = DateTime.now + (Secs * 100)
   Do While DateTime.now < Ti
      DoEvents
   Loop
End Sub

Sub Calendar_Button_Click
	StartActivity("KalenderActivity")
End Sub

Sub MoButton_Click
	ChangeDayButton("Monday")
	dt = MoDat
	FillScrollView
End Sub

Sub TuButton_Click
	ChangeDayButton("Tuesday")
	dt = TuDat
	FillScrollView
End Sub

Sub WeButton_Click
	ChangeDayButton("Wednesday")
	dt = WeDat
	FillScrollView
End Sub

Sub ThButton_Click
	ChangeDayButton("Thursday")
	dt = ThDat
	FillScrollView
End Sub

Sub FrButton_Click
	ChangeDayButton("Friday")
	dt = FrDat
	FillScrollView
End Sub

Sub SaButton_Click
	ChangeDayButton("Saturday")
	dt = SaDat
	FillScrollView
End Sub

Sub SuButton_Click
	ChangeDayButton("Sunday")
	dt = SuDat
	FillScrollView
End Sub

Sub ChangeDayButton(daybut As String)
	MoButton.Enabled = True
	TuButton.Enabled = True
	WeButton.Enabled = True
	ThButton.Enabled = True
	FrButton.Enabled = True
	SaButton.Enabled = True
	SuButton.Enabled = True
	
	DateTime.DateFormat = "dd/MM/yyyy"
	
	Select daybut
		Case "Monday"
			MoButton.Enabled = False
			CurrDate = DateTime.Date(MDate)
		Case "Tuesday"
			TuButton.Enabled = False
			CurrDate = DateTime.Date(DateTime.Add(MDate, 0, 0, 1))
		Case "Wednesday"
			WeButton.Enabled = False
			CurrDate = DateTime.Date(DateTime.Add(MDate, 0, 0, 2))
		Case "Thursday"
			ThButton.Enabled = False
			CurrDate = DateTime.Date(DateTime.Add(MDate, 0, 0, 3))
		Case "Friday"
			FrButton.Enabled = False
			CurrDate = DateTime.Date(DateTime.Add(MDate, 0, 0, 4))
		Case "Saturday"
			SaButton.Enabled = False
			CurrDate = DateTime.Date(DateTime.Add(MDate, 0, 0, 5))
		Case "Sunday"
			SuButton.Enabled = False
			CurrDate = DateTime.Date(DateTime.Add(MDate, 0, 0, 6))
	End Select
	
End Sub

Sub DateRoutines(DateString)
	
	Dim Luup, DayOfWeek As Int
	Dim DLab As String
	
	DateTime.DateFormat = "dd/MM/yyyy"
	Today = DateTime.DateParse(DateString)
	DayOfWeek = DateTime.GetDayOfWeek(Today)-2
	If DayOfWeek < 0 Then DayOfWeek = 6
	MDate = DateTime.Add(Today, 0, 0, 0-DayOfWeek)
	
	DateTime.DateFormat = "d"
	dt = DateTime.Date(MDate)
	
	Select dt
		Case "1", "21", "31"
			dth = "st"
		Case "2", "22"
			dth = "nd"
		Case "3", "23"
			dth = "rd"
		Case Else
			dth = "th"
	End Select
	
	DateTime.DateFormat = "EEEE, d"
	dt = DateTime.Date(MDate)
	dt = dt & dth
	DateTime.DateFormat = " MMMM yyyy"
	dt = dt & DateTime.Date(MDate)
	
	DateLabel.Text = dt
	
	DateTime.DateFormat = "dd/MM/yyyy"
	dt = DateTime.Date(MDate)
	MoDat = DateTime.Date(MDate)
	TuDat = DateTime.Date(DateTime.Add(MDate, 0, 0, 1))
	WeDat = DateTime.Date(DateTime.Add(MDate, 0, 0, 2))
	ThDat = DateTime.Date(DateTime.Add(MDate, 0, 0, 3))
	FrDat = DateTime.Date(DateTime.Add(MDate, 0, 0, 4))
	SaDat = DateTime.Date(DateTime.Add(MDate, 0, 0, 5))
	SuDat = DateTime.Date(DateTime.Add(MDate, 0, 0, 6))
	
	DateTime.DateFormat = "dd/MM"
	MoLab.Text = DateTime.Date(MDate)
	TuLab.Text = DateTime.Date(DateTime.Add(MDate, 0, 0, 1))
	WeLab.Text = DateTime.Date(DateTime.Add(MDate, 0, 0, 2))
	ThLab.Text = DateTime.Date(DateTime.Add(MDate, 0, 0, 3))
	FrLab.Text = DateTime.Date(DateTime.Add(MDate, 0, 0, 4))
	SaLab.Text = DateTime.Date(DateTime.Add(MDate, 0, 0, 5))
	SuLab.Text = DateTime.Date(DateTime.Add(MDate, 0, 0, 6))
	
End Sub

Sub Next_Button_Click
	Dim DLab As String
	
	DateTime.DateFormat = "dd/MM/yyyy"
	DLab = DateTime.Date(DateTime.Add(MDate, 0, 0, 7))
	DateRoutines(DLab)
	ChangeDayButton("Monday")
	FillScrollView
	
End Sub

Sub Prev_Button_Click
	Dim DLab As String
	
	DateTime.DateFormat = "dd/MM/yyyy"
	DLab = DateTime.Date(DateTime.Add(MDate, 0, 0, -7))
	DateRoutines(DLab)
	ChangeDayButton("Monday")
	FillScrollView
	
End Sub

Sub Panel1_Click
	Dim Send As Panel
	Dim Name As String
	Dim TempLab As Label
	
	Send = Sender
	Send.Color = Colors.Yellow
	Wait(1)
	Send.Color = Colors.White
	
	Name = CName(Send.Tag)
	StartTime = STim(Send.Tag)
	EndTime = ETim(Send.Tag)
	Postal = PostCD(Send.Tag)
	
	FName = Name.SubString2(0, Name.IndexOf(" "))
	LName = Name.SubString(Name.IndexOf(" ")+1)
	
	StartActivity(ShiftDetails)
	
End Sub

Sub TodayButton_Click
	DateTime.DateFormat = "dd/MM/yyyy"
	CurrDate = DateTime.Date(DateTime.now)
	DateRoutines(CurrDate)
	
	DateTime.DateFormat = "EEEE"
	dt = DateTime.Date(DateTime.now)
	ChangeDayButton(dt)
	
	FillScrollView
End Sub